package com.yl8timer.kqj.yl8timer;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.autoconfigure.orm.jpa.HibernateJpaAutoConfiguration;
import org.springframework.boot.web.embedded.tomcat.TomcatServletWebServerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@SpringBootApplication(exclude = { DataSourceAutoConfiguration.class, HibernateJpaAutoConfiguration.class })
@RestController
@EnableScheduling
@MapperScan("com.yl8timer.kqj.yl8timer.dao")
public class DemoApplication {

	public static void main(String[] args) {

		SpringApplication.run(DemoApplication.class, args);
	}

	@Bean
	public TomcatServletWebServerFactory createEmbeddedServletContainerFactory() {
		TomcatServletWebServerFactory tomcatFactory = new TomcatServletWebServerFactory();
		tomcatFactory.addConnectorCustomizers(connector -> {
			// AbstractProtocol protocol = (AbstractProtocol)
			// connector.getProtocolHandler();
			// protocol.setSendReasonPhrase(true);
			// connector.setPort(8087);
			connector.setProperty("sendReasonPhrase", "true");
		});
		return tomcatFactory;
	}

	@Value("${spring.profiles.active}")
	private String env;

	@GetMapping(value = "/t")
	public String testEnv() {
		return env;
	}

}
