/**  
* <p>Title: delLogController.java</p>  
* <p>Description: </p>  
* @author dsc  
* @date 2020年5月13日  
* @version 1.0  
*/
package com.yl8timer.kqj.yl8timer.ctrl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;
import org.springframework.scheduling.support.CronTrigger;
import org.springframework.stereotype.Component;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.yl8timer.kqj.yl8timer.entity.fk.FkHsRequest;
import com.yl8timer.kqj.yl8timer.entity.fk.FkHsResponse;
import com.yl8timer.kqj.yl8timer.tools.Constant;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;

/**
 * <p>
 * Title: delLogController.java
 * </p>
 * <p>
 * Description:
 * </p>
 * 
 * @author dsc
 * @date 2020年5月13日
 * @version 1.0
 */
@Component
public class delLogController implements SchedulingConfigurer {

	@Value("${config.retry.day}")
	private Integer day;

	@Value("${config.retry.cron2}")
	private String cron2;

	// 数据库动态更改定时配置
	@Override
	public void configureTasks(ScheduledTaskRegistrar taskRegistrar) {
		taskRegistrar.addTriggerTask(() -> {
			// 任务逻辑
			delLog();
		}, triggerContext -> {
			CronTrigger cronTrigger = new CronTrigger(cron2); // cron配置 30min/次
			return cronTrigger.nextExecutionTime(triggerContext); // 下次执行任务的时间
		});
	}

	private void delLog() {
		DateTime newDate = DateUtil.offsetDay(new Date(), -day); // 时间偏移
		List<FkHsResponse> list = FkHsResponse.builder().build().selectList(new LambdaQueryWrapper<FkHsResponse>()
				.eq(FkHsResponse::getCommand, Constant.REQ_CODE_RECV_CMD).lt(FkHsResponse::getTime, newDate));
		for (FkHsResponse fkHsResponse : list) {
			fkHsResponse.deleteById();
		}
		
		List<FkHsRequest> list2 = FkHsRequest.builder().build().selectList(new LambdaQueryWrapper<FkHsRequest>()
				.lt(FkHsRequest::getTime, newDate));
		for (FkHsRequest fkHsRequest : list2) {
			fkHsRequest.deleteById();
		}
	}
}
