package com.yl8timer.kqj.yl8timer.entity;

import java.io.UnsupportedEncodingException;

public class Command {

	private String TransId;
	private String CmdCode;
	private byte[] bytCmd;
	private String sResponse;
	private String jsonstr;


	/// 命令
	public final static String GET_USER_ID_LIST = "GET_USER_ID_LIST";// 获取用户ID列表
	public final static String SET_USER_INFO = "SET_USER_INFO";// 设置用户信息
	public final static String GET_USER_INFO = "GET_USER_INFO";// 获取用户信息
	public final static String DELETE_USER = "DELETE_USER";// 删除用户
	public final static String CLEAR_ENROLL_DATA = "CLEAR_ENROLL_DATA";// 清除所有用户数据
	public final static String GET_LOG_DATA = "GET_LOG_DATA";// 按时间获取机器上记录
	public final static String CLEAR_LOG_DATA = "CLEAR_LOG_DATA";// 清除设备上所有记录
	public final static String SET_TIMEZONE = "SET_TIMEZONE";// 设置门禁时间组
	public final static String GET_TIMEZONE = "GET_TIMEZONE";// 获取门禁时间组
	public final static String SET_USER_PASSTIME = "SET_USER_PASSTIME";// 设置用户时间段
	public final static String GET_USER_PASSTIME = "GET_USER_PASSTIME";// 设置用户时间段
	public final static String SET_DEVICE_SETTING = "SET_DEVICE_SETTING";// 设置门禁设备参数
	public final static String GET_DEVICE_SETTING = "GET_DEVICE_SETTING";// 获取门禁设备参数
	public final static String SET_DOOR_STATUS = "SET_DOOR_STATUS";// 远程开关门（保留）
	public final static String SET_TIME = "SET_TIME";// 同步设备时间
	public final static String SET_FK_NAME = "SET_FK_NAME";// 设置设备名
	public final static String GET_DEVICE_STATUS = "GET_DEVICE_STATUS";// 获取设备存储状态信息
	public final static String SET_WEB_SERVER_INFO = "SET_WEB_SERVER_INFO";// 设置设备服务器信息
	public final static String UPDATE_FIRMWARE = "UPDATE_FIRMWARE";// 升级设备固件

	// response_code 回复状态
	// 字段表示是否服务器接收实时登记数据而保存成功。
	// OK : 成功
	// ERROR : 失败
	// 如果机器接受ERROR应答就认为传输失败而再次试图传输到传输成功。

	public final static String RESET_FK = "RESET_FK";// 重启设备
	public final static String GET_ALL_USER_INFO = "GET_ALL_USER_INFO";// 获取所有用户信息
	public final static String CLEAN_MANAGER = "CLEAN_MANAGER";// 一键清除设备管理员
	public final static String OK = "OK";
	public final static String ERROR = "ERROR";
	public final static String ERROR_CANCELED = "ERROR_CANCELED";
	public final static String ERROR_ADD_BLOCK_DATA = "ERROR_ADD_BLOCK_DATA";
	public final static String ERROR_INVLAID_BLOCK_NO = "ERROR_INVLAID_BLOCK_NO";
	public final static String ERROR_INVLAID_REQUEST_CODE = "ERROR_INVLAID_REQUEST_CODE";



	public Command() {
		TransId = "";
		CmdCode = "";
		setJsonstr("");
		sResponse = "null";
		bytCmd = new byte[0];
	}

	public Command(String transId, String cmdCode, byte[] bytCmd, String sResponse) {
		TransId = transId;
		CmdCode = cmdCode;
		this.bytCmd = bytCmd;
		this.sResponse = sResponse;
		setJsonstr("");
	}

	public String getTransId() {
		return TransId;
	}

	public void setTransId(String transId) {
		TransId = transId;
	}

	public String getCmdCode() {
		return CmdCode;
	}

	public void setCmdCode(String cmdCode) {
		CmdCode = cmdCode;
	}

	public byte[] getBytCmd() {
		return bytCmd;
	}

	public void setBytCmd(byte[] bytCmd) {
		if (bytCmd == null)
			this.bytCmd = new byte[0];
		else
			this.bytCmd = bytCmd;
	}
	public void getCmdParam(){
		
	}
	public void setBytCmd(String sCmdParam){
		byte[] bytCmd = new byte[0];
		if (sCmdParam.length() != 0) { 
			try {
				byte[] bytText = sCmdParam.getBytes("UTF-8");
				byte[] bytTextLen = int2byte(bytText.length + 1);
				bytCmd = new byte[4 + bytText.length + 1];
				System.arraycopy(bytTextLen, 0, bytCmd, 0, bytTextLen.length);
				System.arraycopy(bytText, 0, bytCmd, 4, bytText.length);
				bytCmd[4 + bytText.length] = 0;
			} catch (UnsupportedEncodingException e) {
			 
			} 
		}
		this.bytCmd = bytCmd;
	}
	public void appendBinData(byte[] abytToAdd) {
		try {
			byte[] bytToAdd = abytToAdd;
			if (bytToAdd.length == 0)
				return;

			int len_dest = this.bytCmd.length + 4 + bytToAdd.length;
			byte[] bytRet = new byte[len_dest];
			byte[] bytAddLen = int2byte(bytToAdd.length);
			System.arraycopy(this.bytCmd, 0, bytRet, 0, this.bytCmd.length);
			System.arraycopy(bytAddLen, 0, bytRet, this.bytCmd.length, 4);
			System.arraycopy(bytToAdd, 0, bytRet, this.bytCmd.length + 4, bytToAdd.length);
			this.bytCmd = bytRet;
		} catch (Exception e) {
		}
	}

	private byte[] int2byte(int res) {
		byte[] targets = new byte[4];
		targets[0] = (byte) (res & 0xff);
		targets[1] = (byte) ((res >> 8) & 0xff);
		targets[2] = (byte) ((res >> 16) & 0xff);
		targets[3] = (byte) (res >>> 24);
		return targets;
	}

	

	public String getsResponse() {
		return sResponse;
	}

	public void setsResponse(String sResponse) {
		this.sResponse = sResponse;
	}

	public String getJsonstr() {
		return jsonstr;
	}

	public void setJsonstr(String jsonstr) {
		this.jsonstr = jsonstr;
	}

	public void clear() {
		TransId = "";
		CmdCode = "";
		setJsonstr("");
		sResponse = "null";
		bytCmd = new byte[0];
	}
}
